package eu.mikroskeem.uurimustoo.algoritmidetest.algoritmid;

import net.jpountz.lz4.LZ4Compressor;
import net.jpountz.lz4.LZ4Factory;
import net.jpountz.lz4.LZ4SafeDecompressor;

/**
 * @author Mark Vainomaa
 */
public class LZ4 extends AbstractAlgorithm {
    @Override public String getName() { return "LZ4"; }
    private final LZ4Factory factory = LZ4Factory.fastestInstance();

    @Override
    public byte[] compress(byte[] input) {
        LZ4Compressor compressor = factory.fastCompressor();
        return compressor.compress(input);
    }

    @Override
    public byte[] decompress(byte[] input) {
        LZ4SafeDecompressor decompressor = factory.safeDecompressor();
        return decompressor.decompress(input, 8192);
    }
}
